#import <space.h>		  //  Space features
#import <gui.h>
#import "NhoodProtestValueGrid.h"			 
#import "WrappedListGrid2d.h"

@interface Citizen: SwarmObject
{
  double unhappiness;		
  int x, y;
  int oldx, oldy;
  int age;	
 
  float randomMoveProbability;		
 
  double probRulerBad;
  double personalCondition;
  double threshold;
  WrappedListGrid2d *positionGrid;			
  int worldXSize, worldYSize;		
  NhoodProtestValueGrid *nhoodProtestValueGrid;				
  Color citizenColor;
  int protesting;
}

- setPositionGrid: (WrappedListGrid2d *)w localProtestValueGrid: (NhoodProtestValueGrid *)h; 

- createEnd;

- (double)getUnhappiness;
-(int) getProtest;
- setPersonalCondition: (double)c;
- setProtestThreshold: (double) t;
- setRandomMoveProbability: (float)p;
- setX: (int)x Y: (int)y;			
- setColor: (Color)c;			  

- step;

- drawSelfOn: (id <Raster>)r;

@end

