#import "ListWrapper.h"
#import "math.h"
#import "Citizen.h"

@implementation ListWrapper

-setFlag
{
  flag=1;
  return self;
}


-(int) addOneProtester
{
  numProtesters=numProtesters + 1; 
  [self setFlag];
  return numProtesters;
}

-(int) removeOneProtester
{
  numProtesters=numProtesters -1;
  [self setFlag];
  return numProtesters;
}

-(int) getNumProtesters
{
  id index;
  id aPerson;

  numProtesters=0;
  index=[list begin: [self getZone]];
  while((aPerson=[index next])!=NULL)
    { 
      if ([aPerson  getProtest]==1) numProtesters++;
    }
  [index drop];

  //now update percent protesting, just for record keeping
  if((populationLevel=[list getCount])==0) 
	      pctProtesting=0;
	    else
	      pctProtesting=(100.0*numProtesters/populationLevel);


  return numProtesters;
}


- setPctProtesting: (double) pct;
{
  pctProtesting=pct;
  return self;
}

-(int)getPopulationLevel
{
   if ((populationLevel=[list getCount])==0) return 0;
   else return populationLevel;

}


- setX: (int) theX Y: (int) theY
{
  x=theX;
  y=theY;
  return self;
}

- setX: (int)theX
{
    x = theX;
    return self;
}
- setY: (int)theY
{
    y = theY;
    return self;
}

-setList:  (id<List>) aList
{
    list=aList;
    return self;
}


// pj Note: This is a nondestructive copy of the input list aList
// into the wrapped list "list"

-setNewList: (id<List>) aList
{
    id index;
    id obj;
    index=[aList begin: [self getZone]];
    while( (obj=[index next])!= NULL)
      {
	[list addLast: obj];
      }
    return self;
}

-(id <List>)getList
{
    return list;
}

- (int)getX
{ 
    return x;
}

- (int)getY
{
    return y;
}

- initializeAllValues
{
   populationLevel=0;
   numProtesters=0;
   pctProtesting=0;
   flag=0;
   return self;
}

- drawSelfOn: (id <Raster>)r;
{
  float color;
  color=  66 + 0.64* pctProtesting;
  //printf("ValueHolder percentProtesting is %d color->%f\n",pctProtesting, color);

  [r drawPointX: x Y: y Color: floor( color + 0.5) ];
  return self;
}


@end 
